"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _reactNative = require("react-native");

function _classPrivateMethodInitSpec(obj, privateSet) { _checkPrivateRedeclaration(obj, privateSet); privateSet.add(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

function _classPrivateMethodGet(receiver, privateSet, fn) { if (!privateSet.has(receiver)) { throw new TypeError("attempted to get private field on non-instance"); } return fn; }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

// This selects between TurboModule and legacy RN library implementation.
const FPStaticServer = global.__turboModuleProxy ? require('./NativeStaticServer').default : _reactNative.NativeModules.RNStaticServer;

var _appStateSub = /*#__PURE__*/new WeakMap();

var _handleAppStateChange = /*#__PURE__*/new WeakSet();

class StaticServer {
  // NOTE: It was type-defed as "number" prior to v0.6.0, but it was wrong,
  // the value was "string" all along.

  /**
   * Creates a new StaticServer instance.
   *
   * Because the legacy, the following alternative signatures are supported,
   * and the overall constructor implementation is thus subpar.
   *
   * new StaticServer(port, root, opts);
   * new StaticServer(port, opts);
   * new StaticServer(port, root);
   * new StaticServer(opts);
   * new StaticServer(port);
   * new StaticServer();
   *
   * @param portOrOpts
   * @param rootOrOpts
   * @param opts
   */
  constructor(portOrOpts, rootOrOpts, opts) {
    _classPrivateMethodInitSpec(this, _handleAppStateChange);

    _classPrivateFieldInitSpec(this, _appStateSub, {
      writable: true,
      value: void 0
    });

    _defineProperty(this, "_origin", void 0);

    _defineProperty(this, "keepAlive", void 0);

    _defineProperty(this, "localOnly", void 0);

    _defineProperty(this, "port", '');

    _defineProperty(this, "root", void 0);

    _defineProperty(this, "running", false);

    _defineProperty(this, "started", false);

    switch (arguments.length) {
      case 3:
        this.port = `${portOrOpts}`;
        if (typeof rootOrOpts === 'string') this.root = rootOrOpts || null;else if (!rootOrOpts) this.root = null;else throw Error('Invalid "root" type');
        this.localOnly = opts && opts.localOnly || false;
        this.keepAlive = opts && opts.keepAlive || false;
        break;

      case 2:
        this.port = `${portOrOpts}`;

        if (typeof rootOrOpts === 'string') {
          this.root = rootOrOpts;
          this.localOnly = false;
          this.keepAlive = false;
        } else {
          this.root = null;
          this.localOnly = rootOrOpts && rootOrOpts.localOnly || false;
          this.keepAlive = rootOrOpts && rootOrOpts.keepAlive || false;
        }

        break;

      case 1:
        if (typeof portOrOpts === 'number') {
          this.port = `${portOrOpts}`;
          this.root = null;
          this.localOnly = false;
          this.keepAlive = false;
        } else {
          this.port = '';
          this.root = null;
          this.localOnly = portOrOpts && portOrOpts.localOnly || false;
          this.keepAlive = portOrOpts && portOrOpts.keepAlive || false;
        }

        break;

      default:
        this.port = '';
        this.root = null;
        this.localOnly = false;
        this.keepAlive = false;
    }
  }

  start() {
    if (this.running) {
      return Promise.resolve(this.origin);
    }

    this.started = true;
    this.running = true;

    if (!this.keepAlive && _reactNative.Platform.OS === 'android') {
      _classPrivateFieldSet(this, _appStateSub, _reactNative.AppState.addEventListener('change', _classPrivateMethodGet(this, _handleAppStateChange, _handleAppStateChange2).bind(this)));
    }

    return FPStaticServer.start(this.port, this.root, this.localOnly, this.keepAlive).then(origin => {
      this._origin = origin;
      return origin;
    });
  }

  stop() {
    this.running = false;
    return FPStaticServer.stop();
  }

  kill() {
    this.stop();
    this.started = false;
    this._origin = undefined;
    if (_classPrivateFieldGet(this, _appStateSub)) _classPrivateFieldGet(this, _appStateSub).remove();
  }

  get origin() {
    return this._origin;
  }

  isRunning() {
    return FPStaticServer.isRunning().then(running => {
      this.running = running;
      return this.running;
    });
  }

}

function _handleAppStateChange2(appState) {
  if (!this.started) {
    return;
  }

  if (appState === 'active' && !this.running) {
    this.start();
  }

  if (appState === 'background' && this.running) {
    this.stop();
  }

  if (appState === 'inactive' && this.running) {
    this.stop();
  }
}

var _default = StaticServer;
exports.default = _default;
//# sourceMappingURL=index.js.map