declare global {
    var __turboModuleProxy: object | undefined;
}
declare type Options = {
    keepAlive?: boolean;
    localOnly?: boolean;
};
declare class StaticServer {
    #private;
    _origin?: string;
    keepAlive: boolean;
    localOnly: boolean;
    port: string;
    root: null | string;
    running: boolean;
    started: boolean;
    /**
     * Creates a new StaticServer instance.
     *
     * Because the legacy, the following alternative signatures are supported,
     * and the overall constructor implementation is thus subpar.
     *
     * new StaticServer(port, root, opts);
     * new StaticServer(port, opts);
     * new StaticServer(port, root);
     * new StaticServer(opts);
     * new StaticServer(port);
     * new StaticServer();
     *
     * @param portOrOpts
     * @param rootOrOpts
     * @param opts
     */
    constructor(portOrOpts?: number | Options, rootOrOpts?: Options | string, opts?: Options);
    start(): Promise<string>;
    stop(): Promise<void>;
    kill(): void;
    get origin(): string | undefined;
    isRunning(): Promise<boolean>;
}
export default StaticServer;
